#ifndef _dbpri_h_
#define _dbpri_h_

#include <stdarg.h>
#include <stdio.h>
#include <time.h>

#ifdef _DBGPRINT_
	#define dbgpri(...) dbgpri_impl(__VA_ARGS__)
#else
	#define dbgpri(...)
#endif

static void dbgpri_impl(const char *fmt, ...)
{
	va_list args;
	struct timespec now;
	char msg[2048];

	va_start(args, fmt);
	clock_gettime(CLOCK_MONOTONIC_RAW, &now);
	vsnprintf(msg, sizeof(msg), fmt, args);
	fprintf(stderr, "[%ld.%-9ld] %s\n", now.tv_sec, now.tv_nsec, msg);

	va_end(args);
}

static void dbgput(const char *str)
{
	fprintf(stderr, "%s\n", str);
}

#endif
