# Pila
A simple, terse (and barely any useful) stack language.
I wanted to learn Common Lisp so I thought it would be nice to write a
RPN calculator, but it began to grow out of control and now is a turing-complete
(I think) stack language, with loops, conditionals and subroutines.

## Usage
Load the `pila.asd` system and evaluate `(pila:main)` which is the interpreter's
entry point.

Alternatively you can use the provided makefile and use
```
make build
```
to build an executable.
Note that the makefile assumes that you're using SBCL.

Pila takes a command line argument specifying which file to load and execute:
```
pila foo.pila
```
If no file was specified it will drop to Pila's REPL.

## Examples
See the `examples` folder.

<!--
## Plans
This was originally just a simple RPN calculator,
however I got tempted into adding more words eventually making it turing-complete.
By no means Pila is a practical language, probably it would fit in a code golfing
competition.

I plan to keep working on it just for fun and add some other features:
### Anonymous words
```
: foo print-top inc ;
0 10 'foo dotimes
```
would become
```
0 10 {print-top inc} dotimes
```
Notice that there is no space between `{` and the first word within since
I plan on making the spacing requirement more lax as long as parsing don't become
ambiguous.

### Variables
```
127 %foo set
%foo 2 * .
```
Note the sigil, since we would need to distinguish between a word and a variable
beforehand. Probably there is a way to drop the sigil?
Forth has `variable foo` to declare a new variable, but looks like a special exception
from the RPN stack syntax.

### Arrays
```
[1, 2, 3, 4] %arr set
%arr length .
%arr 'inc map!      \ <== in-place map
%arr .              \ <== [2, 3, 4, 5]
2 %arr elt .        \ <== 3
```
-->
