(in-package :pila)

(defmacro make-dynarray (size)
  `(make-array ,size :adjustable t :fill-pointer 0))

(defun vector-last (vec)
  "Returns the last element of a vector."
  (declare ((vector *) vec))
  (when (zerop (length vec))
    (error "Stack is empty"))
  (aref vec (1- (length vec))))

(defun string-slice (source-string start &optional end)
  "Creates a slice (shallow copy) of a source-string bounded by start
  and end."
  (when (null end)
    (setf end (length source-string)))
  (let ((slice (make-array 0
                           :element-type 'character
                           :displaced-to " "
                           :displaced-index-offset 0)))
    (coerce (adjust-array slice (- end start)
                          :displaced-to source-string
                          :displaced-index-offset start)
            'simple-string)))
